%{
#include "input.tab.h"
extern int linenumber;
%}

%%

[\n] { linenumber++; }

#.*$  {}
[ \t]*     {}

^ACTI       { return ACTI ;}
^END        { return END ;}
^EXEC       { return EXEC ;}
^TASK       { return TASK;}
^RESOURCE   { return RESOURCE;}
^":BODY"   { return ENDHEAD;}
[0-9]+      { sscanf (yytext,"%ld", &(yylval.ivalue));
              return(NUM);
            }
\".*\"     { yylval.cvalue=yytext;
              return(IDEN);
            }


