
#define MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>

#include <linux/cons.h>

#include <linux/rt_sched.h>
#include <linux/rt_fifo.h>

#define NTASKS 6

RT_TASK tasks[NTASKS];


struct {         /*  De esta estructura toman los datos las tareas */
  int id;
  int compute;
  int period;
  int deadline;
} Parameters[NTASKS];



/* t -- the fifo number */
void fun(int computo) {
  int bucle,x;
  while(1){
    
    for (bucle=0; bucle < computo ; bucle++){
      for (x=0; x<1000; x++);
    }
    
    rt_task_wait();
  }
}


int init_module(void)
{
  RTIME now = rt_get_time();
  int x;

  Parameters[0].compute=2;
  Parameters[0].period=1000;
  Parameters[0].deadline=500;

  Parameters[1].compute=30;
  Parameters[1].period=15000;
  Parameters[1].deadline=10000;

  Parameters[2].compute=20;
  Parameters[2].period=16000;
  Parameters[2].deadline=15000;

  Parameters[3].compute=30;
  Parameters[3].period=45000;
  Parameters[3].deadline=45000;

  Parameters[4].compute=8;
  Parameters[4].period=3500;
  Parameters[4].deadline=1000;

  Parameters[5].compute=2;
  Parameters[5].period=2100;
  Parameters[5].deadline=600;
  


  for (x=0; x<NTASKS; x++){
    rt_task_init(&(tasks[x]), fun, Parameters[x].compute , 3000, x+1, x+1);
  }
  for (x=0; x<NTASKS; x++){
    rt_task_make_periodic(&(tasks[x]), now+(RTIME)1000, 
                          (RTIME)  Parameters[x].period,
                          (RTIME) Parameters[x].deadline);

  }

  return 0;
}


void cleanup_module(void)
{
  int x;
  for (x=0; x<NTASKS; x++){
    rt_task_delete(&(tasks[x]));
  }
}

/*
 * Overrides for Emacs so that we almost follow Linus's tabbing style.
 * Emacs will notice this stuff at the end of the file and automatically
 * adjust the settings for this buffer only.  This must remain at the end
 * of the file.
 * ---------------------------------------------------------------------------
 * Local variables:
 * c-indent-level: 4
 * c-brace-imaginary-offset: 0
 * c-brace-offset: -4
 * c-argdecl-indent: 4
 * c-label-offset: -4
 * c-continued-statement-offset: 4
 * c-continued-brace-offset: 0
 * indent-tabs-mode: nil
 * tab-width: 8
 * End:
 */

